resource_types:
- name: s3-resource-simple
  type: docker-image
  source:
    repository: cincan/s3-resource-simple

resources:
- name: s3-in
  type: s3-resource-simple
  check_every: 30s
  source:
    access_key_id: ((s3-access-id))
    secret_access_key: ((s3-access-key))
    bucket: concourse-input
    endpoint: ((s3-endpoint))
    options:
    - "--exclude '*'"
    - "--include '*.pcap'"
    - "--exclude 's3-*'"
    - "--no-verify-ssl"
    - "--delete"

- name: s3-archive
  type: s3-resource-simple
  source:
    access_key_id: ((s3-access-id))
    secret_access_key: ((s3-access-key))
    bucket: concourse-archive
    endpoint: ((s3-endpoint))
    options:
    - "--exclude '*'"
    - "--include '*.pcap'"
    - "--no-verify-ssl"

- name: s3-out
  type: s3-resource-simple
  source:
    access_key_id: ((s3-access-id))
    secret_access_key: ((s3-access-key))
    bucket: concourse-output
    endpoint: ((s3-endpoint))
    options:
    - "--include '*'"
    - "--exclude 's3-*'"
    - "--no-verify-ssl"

jobs:
- name: suricata-virustotal
  serial: true
  plan:
  - get: s3-in
    trigger: true
  - task: suricata-run
    config:
      platform: linux
      image_resource:
        type: docker-image
        source: {repository: cincan/suricata}
      inputs:
      - name: s3-in
        path: pcaps
      outputs:
      - name: suricata-results
      run:
        path: sh
        args:
        - -exc
        - |
          suricata -r pcaps/ -l suricata-results/
          rm -r pcaps/*
  - put: s3-out
  - put: s3-archive
  - put: s3-in

  - task: iocextract-run
    config:
      platform: linux
      image_resource:
        type: docker-image
        source: {repository: cincan/iocextract}
      inputs:
      - name: suricata-results
      outputs:
      - name: iocextract-results
      run:
        path: sh
        args:
        - -exc
        - |
          python3 /extract.py --path suricata-results/ --output iocextract-results/ --hash -v
  - put: s3-out

  - task: virustotal-run
    config:
      platform: linux
      image_resource:
        type: docker-image
        source: {repository: cincan/virustotal}
      inputs:
      - name: iocextract-results
      outputs:
      - name: virustotal-results
      run:
        path: sh
        args:
        - -exc
        - |
          python3 /virustotal.py --files_hash iocextract-results/hashes/ --output virustotal-results/ -v --api_key ${VIRUSTOTAL_APIKEY} --config /config.json
      params:
        VIRUSTOTAL_APIKEY: ((virustotal-api-key))
  - put: s3-out
